/**
	by LINK/2012 (http://www.link2012world.blogspot.com/)
*/
#define IS_ADDRESSES_CPP
#include "Addresses.h"
#include "CBirds.h"
#include "CCamera.h"

#define AssignAddress(into, offset)	into = reinterpret_cast<decltype(into)>(offset)

inline void Setup_Directory()
{
	AssignAddress(chdirUserDir, 0x538860);
	AssignAddress(chdirProgramDir, 0x5387D0);
}

inline void Setup_CFileMgr()
{
	AssignAddress(CFileMgr__getConfigLine, 0x536F80);
}

inline void Setup_ScriptEngine()
{
	AssignAddress(CRunningScript__CollectStringParameter, 0x463D50);
	AssignAddress(CRunningScript__CollectParameters, 0x464080);
	AssignAddress(CRunningScript__GetLocalVariable, 0x463CA0);
	AssignAddress(CRunningScript__UpdateCompareFlag, 0x4859D0);

	AssignAddress(CollectiveArray, 0xA43C78);
}


inline void Setup_TextureDictionary()
{
	AssignAddress(txdLoad, 0x7320B0);
	AssignAddress(txdAddRef, 0x731A00);
	AssignAddress(txdAdd, 0x731C80);
	AssignAddress(txdIndexByName, 0x731850);
	AssignAddress(txdSetCurrent, 0x7319C0);
	AssignAddress(texDictionaryRemove, 0x731CD0);
	AssignAddress(txdRemove, 0x731E90);
}


inline void Setup_RenderWare()
{
	AssignAddress(pRwEngineInstance, 0xC97B24);
	AssignAddress(RwReadTexture, 0x7F3AC0);
	AssignAddress(RwTextureDestroy, 0x7F3820);
	
	AssignAddress(RwIm3DTransform, 0x7EF450);
	AssignAddress(RwIm3DEnd, 0x7EF520);
	AssignAddress(RwIm3DRenderPrimitive, 0x7EF6B0);
	AssignAddress(RwIm3DRenderIndexedPrimitive, 0x7EF550);
}



inline void Setup_CColLine()
{
	AssignAddress(CColLine__Constructor, 0x40EF50);
	AssignAddress(CColLine__HasCollisionWithSphere, 0x417470);
};

inline void Setup_Others()
{
	AssignAddress(camera, 0xB6F028);
	AssignAddress(currentDayOfWeek, 0xB7014E);
	AssignAddress(currentTimeSeconds, 0xB70150);
	AssignAddress(currentTimeMinutes, 0xB70152);
	AssignAddress(currentTimeHours, 0xB70153);
	AssignAddress(currentMonthDay, 0xB70154);
	AssignAddress(currentMonth, 0xB70155);
	AssignAddress(currentTime, 0xB7CB84);
	AssignAddress(TimeStep, 0xB7CB5C);
	AssignAddress(playingTime, 0xB7CB4C);
	AssignAddress(wTownID, 0xC81314);
	AssignAddress(activeInterior, 0xB72914);
	
	AssignAddress(PrintNow, 0x69F1E0);
	AssignAddress(CWaterLevel__GetWaterLevelNoWaves, 0x6E8580);

	AssignAddress(CVector__normalize, 0x59C910);
	AssignAddress(transformPoint, 0x59C890);
	AssignAddress(CMatrix__initIdentityMatrixAtPoint, 0x59AF40);
	AssignAddress(CMatrix__destructor, 0x59ACD0);
	
	AssignAddress(ConvertGlobalXYToScreenXY, 0x70CE30);

	AssignAddress(numVerts, 0xC4B950);
	AssignAddress(numIndices, 0xC4B954);
	AssignAddress(pVerts, 0xC4D958);


	AssignAddress(IsLineOfSightClear, 0x56A490);

	AssignAddress(FindGroundZFor3DCoord, 0x5696C0);
	AssignAddress(FindGroundZForCoord, 0x569660);

	AssignAddress(random, 0x407180);
	AssignAddress(randomf, 0x41BD90);
}
      
inline void Setup_CCollision()
{
	Setup_CColLine();
}





typedef void (*InitCallback)();
void InitAddresses(InitCallback cb)
{
	Setup_CFileMgr();
	Setup_Directory();
	
	Setup_ScriptEngine();

	Setup_RenderWare();
	Setup_TextureDictionary();
	
	Setup_CCollision();
	Setup_Others();

	if(cb != nullptr) cb();
}
