/**
	by LINK/2012 (http://www.link2012world.blogspot.com/)
*/
#pragma once
//
// TODO: Update CRunningScript to CRunningScript
//

// Basic headers
#include <cstdio>
#include <cstdlib>
#include <Windows.h>

// RenderWare structures
#include "RwV3D.h"
#include "RwTexture.h"
#include "RwEngineInstance.h"
#include "RxObjSpace3dVertex.h"

// Game structures
#include "CRunningScript.h"	
#include "CColLine.h"
#include "ColSphere.h"
#include "CCamera.h"
#include "CMatrix.h"


// Trick macro!
#ifdef IS_ADDRESSES_CPP
#define EXTERN
#else
#define EXTERN extern
#endif

typedef void (*InitCallback)();
EXTERN void InitAddresses(InitCallback cb = nullptr);

// Directory Functions
EXTERN const char* programPath;
EXTERN void (*chdirUserDir)();
EXTERN void (*chdirProgramDir)(const char* dir);


// CFileMgr
typedef char* (*CFileMgr__getConfigLine_t)(FILE* file);
EXTERN char* (*CFileMgr__getConfigLine)(FILE* file);

// CRunningScript
EXTERN void (__fastcall *CRunningScript__CollectStringParameter)(CRunningScript* thread, BYTE _unused, char* ptr, size_t len);
EXTERN void (__fastcall *CRunningScript__CollectParameters)(CRunningScript* thread, BYTE _unused, short count);
EXTERN ScriptVar* (__fastcall *CRunningScript__GetLocalVariable)(CRunningScript* thread, BYTE _unused, int idx);
EXTERN void (__fastcall *CRunningScript__UpdateCompareFlag)(CRunningScript* thread, BYTE _unused, bool a2);
EXTERN ScriptVar* CollectiveArray;

// Texture Dictionary
typedef int (*txdLoad_t)(int index, const char* filename);
typedef void* (*txdAddRef_t)(int index);
typedef int (*txdAdd_t)(const char* name);
typedef int (*txdIndexByName_t)(const char* name);
typedef void (*txdSetCurrent_t)(int index);
typedef void (*txdRemove_t)(int index);
typedef void (*texDictionaryRemove_t)(int index);
EXTERN txdLoad_t txdLoad;
EXTERN txdAddRef_t txdAddRef;
EXTERN txdAdd_t txdAdd;
EXTERN txdIndexByName_t txdIndexByName;
EXTERN txdSetCurrent_t txdSetCurrent;
EXTERN txdRemove_t txdRemove;
EXTERN texDictionaryRemove_t texDictionaryRemove;


// RenderWare
EXTERN RwEngineInstance** pRwEngineInstance;

EXTERN RwTexture* (*RwReadTexture)(const char* name, const char* mask);
EXTERN void  (*RwTextureDestroy)(RwTexture* texture);

EXTERN void* (*RwIm3DTransform)(RxObjSpace3dVertex* pVerts, unsigned int numVerts, RwMatrix* ltm, unsigned int flags);
EXTERN void  (*RwIm3DEnd)(void);
EXTERN bool  (*RwIm3DRenderPrimitive)(int primType);
EXTERN bool  (*RwIm3DRenderIndexedPrimitive)(int primtype, void *indices, int numIndices);


// Vector, RwV3D, Matrix
typedef RwV3D CVector;
EXTERN void (__fastcall *CVector__normalize)(CVector* self);
EXTERN void (__cdecl *transformPoint)(RwV3D* outPoint, CMatrix* m, RwV3D* point);
EXTERN void (__fastcall *CMatrix__initIdentityMatrixAtPoint)(CMatrix* self, int dummy, RwV3D point);
EXTERN void (__fastcall *CMatrix__destructor)(CMatrix* self);
EXTERN bool (__cdecl *ConvertGlobalXYToScreenXY)(RwV3D* inPoint, RwV3D* out, float* a3, float* a4, bool a5, bool a6);

// CColLine
typedef void (__fastcall *CColLine__Constructor_t)(CColLine* self, int dummy, RwV3D* p1, RwV3D* p2); // 0x40EF50
typedef bool (__cdecl *CColLine__HasCollisionWithSphere_t)(CColLine* a1, ColSphere* a2);	// 0x417470
EXTERN CColLine__Constructor_t CColLine__Constructor;
EXTERN CColLine__HasCollisionWithSphere_t CColLine__HasCollisionWithSphere;


// Interaction
EXTERN void (*PrintNow)(const char* text, int time, bool addToBrief);

// Others
EXTERN bool (*IsLineOfSightClear)(RwV3D *a1, RwV3D *a2, bool checkBuildings, bool checkVehicles,
	bool checkPeds, bool checkObjects, bool checkDummies, bool seeThroughStuff, bool ignoreSomeObjectsForCamera);
EXTERN bool (*CWaterLevel__GetWaterLevelNoWaves)(float x, float y, float z, float* out1, float* unk1, float* unk2);

EXTERN  float (*FindGroundZFor3DCoord)(float x, float y, float z, bool* success, void* unk);
EXTERN  float (*FindGroundZForCoord)(float x, float y);

EXTERN int (__cdecl *random)(int a, int b);
EXTERN float (__cdecl *randomf)(float a, float b);


// Others game variables
EXTERN CCamera* camera;
// Time
EXTERN BYTE* currentDayOfWeek;
EXTERN WORD* currentTimeSeconds;
EXTERN BYTE* currentTimeMinutes;
EXTERN BYTE* currentTimeHours;
EXTERN BYTE* currentMonthDay;
EXTERN BYTE* currentMonth;
EXTERN DWORD* currentTime;
EXTERN DWORD* playingTime;
EXTERN WORD* wTownID;
EXTERN DWORD* activeInterior;
EXTERN float* TimeStep;

EXTERN int* numIndices;
EXTERN int* numVerts;
EXTERN RxObjSpace3dVertex* pVerts;


#undef EXTERN


// Town ID
enum TownID
{
	Countryside,
	LS,
	SF,
    LV,
	Desert,
	_Others
};



/* Additional:
#define RAND_MAX_DIV_BY_1	0.00003051850947599719
inline float randomf(float a, float b)
{
	return float((rand() * RAND_MAX_DIV_BY_1) * (b-a) + a);
}
inline int random(int a, int b)
{
	return(a + ((b-a) * rand() / (RAND_MAX + 1)));
}
#undef RAND_MAX_DIV_BY_1*/

inline ScriptVar CRunningScript__CollectNextParameter(CRunningScript* thread)
{
	CRunningScript__CollectParameters(thread, 0, 1);
	return CollectiveArray[0];
}

