/**
	The Birds Update
	ASI Plugin	(Programming)	- by LINK/2012		(http://www.link2012world.blogspot.com/)
	New Birds	(Textures)		- by Junior_Djjr	(http://juniordjjr.blogspot.com.br/)
*/
#include "Commands.h"
#include "Addresses.h"
#include "CBirds.h"
#include "Hooks.h"

//---------------------------------------------------------------------------------------
// 0876 - CREATE_FLYING_BIRD_FLOCK
// CREATE_FLYING_BIRD_FLOCK at 0@ 1@ 2@ destination -2630 1411 28 quantity 1 type 0
// CREATE_FLYING_BIRD_FLOCK at 0@ 1@ 2@ destination -2630 1411 28 quantity 1 type "EAGLE"
//
void __declspec(naked) Command_0876()
{
	// ebp has script pointer
	CRunningScript* thread;

	__asm mov ecx, ebp
	__asm mov ebp, [esp+8]
	ASM_PROLOG();
	__asm mov thread, ecx

	{
		RwV3D pos, dest;
		int bird_count, bird_index;
		int nBirdCreatedBefore;
		
		nBirdCreatedBefore = *CBirds::nBirdsCreated;
		
		CRunningScript__CollectParameters(thread, 0, 7);
		pos.x = (float) CollectiveArray[0].nParam;
		pos.y = (float) CollectiveArray[1].nParam;
		pos.z = (float) CollectiveArray[2].nParam;
		dest.x = (float) CollectiveArray[3].nParam;
		dest.y = (float) CollectiveArray[4].nParam;
		dest.z = (float) CollectiveArray[5].nParam;
		
		bird_count = CollectiveArray[6].nParam;

		// If is the bird type parameter is a integer, then collect a integer,
		// otherwise collect a string and get the index by the bird name.
		if(*thread->_ip <= 8)
		{
			bird_index = CRunningScript__CollectNextParameter(thread).nParam;
			if(bird_index == -1) bird_index = CBirds::GetRandomBirdType();
		}
		else
		{
			char buf[32];
			CRunningScript__CollectStringParameter(thread, 0, buf, 16); buf[15] = 0;
			if(*buf == 0)	// No name?
				bird_index = CBirds::GetRandomBirdType();
			else
				bird_index = CBirds::GetBirdIndexByIdentifier(buf);
		}

		if(bird_count == -1 && bird_index > -1)
		{
			bird_count = random(BirdTypes[bird_index].BirdsInFlock.Min,
								BirdTypes[bird_index].BirdsInFlock.Max);
		}

		if(bird_index > -1 && bird_count > 0)
			CBirds::Add(pos, dest, bird_count, bird_index, false);

		// Update compare flag, if created any bird the command would return true, otherwise false.
		CRunningScript__UpdateCompareFlag(thread, 0, nBirdCreatedBefore != *CBirds::nBirdsCreated);
	}

	ASM_EPILOG();
	__asm mov eax, 0x4719F9
	__asm jmp eax
}
//---------------------------------------------------------------------------------------
