/**
	by LINK/2012 (http://www.link2012world.blogspot.com/)
*/
#include "Injector.h"


void WriteMemoryRaw(memory_pointer Address, void* value, size_t size, bool vp)
{
	DWORD oldProtect;
	if(vp) UnprotectMemory(Address, size, oldProtect);
 
	memcpy(Address, value, size);
 
	if(vp) ProtectMemory(Address, size, oldProtect);
}

void ReadMemoryRaw(memory_pointer Address, void* ret, size_t size, bool vp)
{
	DWORD oldProtect;
	if(vp) UnprotectMemory(Address, size, oldProtect);
 
	switch(size)
	{
		case 1:
			*(uint8_t*)ret = *(uint8_t*)Address.p;
			break;
		case 2:
			*(uint16_t*)ret = *(uint16_t*)Address.p;
			break;
		case 4:
			*(uint32_t*)ret = *(uint32_t*)Address.p;
			break;
		default:
			memcpy(ret, Address, size);
			break;
	}

	if(vp) ProtectMemory(Address, size, oldProtect);
}


GameVersion& GameVersion::Get()
{
    switch(ReadMemoryNow<uint8_t>(0x400088, true))
    {
		case 0x8A:
			return m_Version = this->SA_10EU, *this;
		case 0xCA:
			return m_Version = this->SA_10US, *this;
		case 0xD0:
			return m_Version = this->SA_101EU, *this;
		default:
			return m_Version = this->UNKNOWN, *this;
    }
}

const char* GameVersion::GetString()
{
	switch(this->m_Version)
	{
		case this->SA_10US:
			return "GTA_SA 1.0 US";
		case this->SA_10EU:
			return "GTA_SA 1.0 EU";
		case this->SA_101EU:
			return "GTA_SA 1.01 EU";
		default:
			return "UNKNOWN";
	}
}


