/**
	The Birds Update
	ASI Plugin	(Programming)	- by LINK/2012		(http://www.link2012world.blogspot.com/)
	New Birds	(Textures)		- by Junior_Djjr	(http://juniordjjr.blogspot.com.br/)
*/
#pragma once
#include <vector>
#include "RwV3D.h"
#include "RenderWare.h"

//------------------------------------------------//
//		Structures\Enum\etc declaration			  //
//------------------------------------------------//

template <class T> struct MinMax
{
	T Min;
	T Max;
};


enum EnumBirdFlags
{
	BIRD_SPAWN_NEAR_WATER			= 1,	// The bird will spawn when there's water near
	BIRD_GLIDABLE					= 2,	// The bird will glid sometimes (stop fluttering sometimes)
	BIRD_HEIGHT_RELATIVE_TO_CAMERA	= 4,
	BIRD_HEIGHT_RELATIVE_TO_GROUND	= 8,

	BIRD_MAX_FLAG					= 16
};

#define GetFlag(v, f) ((v & f) != 0)

#pragma pack(push, 1)
struct BirdType
{
	// User configurable data:
		char			Identifier[16];
		int				ForceType;
		bool			SpawningTown[5];
		MinMax<int>		SpawnTime;
		MinMax<int>		BirdsInFlock;
		MinMax<float>	Height;
		MinMax<float>	Size;
		float			Distance;
		float			Speed;
		int				WingSpeedDiv;
		unsigned int	Flags;
		

	// Other data
		RwTexture*		m_Texture;

	//
		BirdType() { *Identifier = 0; }
};
#pragma pack(pop)

static_assert(sizeof(BirdType) == 77, "...");

typedef std::vector<BirdType> BirdTypeVector;

//------------------------------------------------//
////////////	Data declaration		////////////
//------------------------------------------------//
extern BirdTypeVector BirdTypes;



//------------------------------------------------//
////////////	Function declaration	////////////
//------------------------------------------------//

BirdTypeVector& GetBirdsData(const char* dataFilename, BirdTypeVector& result);
bool RewriteBirdsData();
void DestroyBirdsDictionary(BirdTypeVector& br);

BirdTypeVector&
	ReadBirdsTextures(BirdTypeVector& br);
