/**
	by LINK/2012 (http://www.link2012world.blogspot.com/)
	
	This file is a compilation of some RenderWare definitions
	RenderWare is (C) Criterion Software
*/
#pragma once
#include "Hooks.h"
#include "Addresses.h"


/*************	ORIGINAL RENDERWARE DEFINITIONS BEGINS HERE *************/
#define MACRO_START do
#define MACRO_STOP while(0)

typedef RxObjSpace3dVertex RwIm3DVertex;

enum RwRenderState
{
    rwRENDERSTATENARENDERSTATE = 0,

    rwRENDERSTATETEXTURERASTER,
    rwRENDERSTATETEXTUREADDRESS,
    rwRENDERSTATETEXTUREADDRESSU,
    rwRENDERSTATETEXTUREADDRESSV,
    rwRENDERSTATETEXTUREPERSPECTIVE,
    rwRENDERSTATEZTESTENABLE,
    rwRENDERSTATESHADEMODE,
    rwRENDERSTATEZWRITEENABLE,
    rwRENDERSTATETEXTUREFILTER,
    rwRENDERSTATESRCBLEND,
    rwRENDERSTATEDESTBLEND,
    rwRENDERSTATEVERTEXALPHAENABLE,
    rwRENDERSTATEBORDERCOLOR,
    rwRENDERSTATEFOGENABLE,
    rwRENDERSTATEFOGCOLOR,
    rwRENDERSTATEFOGTYPE,
    rwRENDERSTATEFOGDENSITY,
    rwRENDERSTATECULLMODE = 20,
    rwRENDERSTATESTENCILENABLE,
    rwRENDERSTATESTENCILFAIL,
    rwRENDERSTATESTENCILZFAIL,
    rwRENDERSTATESTENCILPASS,
    rwRENDERSTATESTENCILFUNCTION,
    rwRENDERSTATESTENCILFUNCTIONREF,
    rwRENDERSTATESTENCILFUNCTIONMASK,
    rwRENDERSTATESTENCILFUNCTIONWRITEMASK,
    rwRENDERSTATEALPHATESTFUNCTION,
    rwRENDERSTATEALPHATESTFUNCTIONREF,
};

enum RwPrimitiveType
{
    rwPRIMTYPENAPRIMTYPE = 0,
    rwPRIMTYPELINELIST = 1,
    rwPRIMTYPEPOLYLINE = 2,
    rwPRIMTYPETRILIST = 3,
    rwPRIMTYPETRISTRIP = 4,
    rwPRIMTYPETRIFAN = 5,
    rwPRIMTYPEPOINTLIST = 6,
};

enum RwIm3DTransformFlags
{
    rwIM3D_VERTEXUV      = 1,
    rwIM3D_ALLOPAQUE     = 2,
    rwIM3D_NOCLIP        = 4,
    rwIM3D_VERTEXXYZ     = 8,
    rwIM3D_VERTEXRGBA    = 16
};

enum RwShadeMode
{
    rwSHADEMODENASHADEMODE = 0,
    rwSHADEMODEFLAT,
    rwSHADEMODEGOURAUD
};

enum RwBlendFunction
{
    rwBLENDNABLEND = 0,
    rwBLENDZERO,
    rwBLENDONE,
    rwBLENDSRCCOLOR,
    rwBLENDINVSRCCOLOR,
    rwBLENDSRCALPHA,
    rwBLENDINVSRCALPHA,
    rwBLENDDESTALPHA,
    rwBLENDINVDESTALPHA,
    rwBLENDDESTCOLOR,
    rwBLENDINVDESTCOLOR,
    rwBLENDSRCALPHASAT
};

enum RwTextureFilterMode
{
    rwFILTERNAFILTERMODE = 0,
    rwFILTERNEAREST,
    rwFILTERLINEAR,
    rwFILTERMIPNEAREST,
    rwFILTERMIPLINEAR,
    rwFILTERLINEARMIPNEAREST,
    rwFILTERLINEARMIPLINEAR
};

#define RwIm3DVertexSetPos(_vert, _imx, _imy, _imz) \
MACRO_START \
{ \
    (_vert)->objVertex.x = _imx; \
    (_vert)->objVertex.y = _imy; \
    (_vert)->objVertex.z = _imz; \
} \
MACRO_STOP

#define RwIm3DVertexSetRGBA(_vert, _r, _g, _b, _a) \
MACRO_START \
{ \
    ((_vert)->color = ((_a) << 24) | \
                              ((_r) << 16) | \
                              ((_g) << 8) | \
                              ((_b))); \
} \
MACRO_STOP

#define RwIm3DVertexGetU(_vert) \
    ((_vert)->u)
#define RwIm3DVertexGetV(_vert) \
    ((_vert)->v)
#define RwIm3DVertexSetU(_vert, _imu) \
    ((_vert)->u = (_imu))
#define RwIm3DVertexSetV(_vert, _imv) \
    ((_vert)->v = (_imv))



/*************	ORIGINAL RENDERWARE DEFINITIONS ENDS HERE *************/



//******************************************************************************************************//
//
//	Easy call to RenderWare functions that have a pointer stored in RenderWare instance structure.
//
//******************************************************************************************************//

inline bool NAKED __fastcall RwRenderStateGet(RwRenderState state, void *value)
{
	__asm
	{
		push	edx
		push	ecx
		mov		eax, dword ptr ds:[0xC97B24]
		call	[eax+0x24]
		add		esp, 8
		retn
	};
}

inline bool NAKED __fastcall RwRenderStateSet(RwRenderState state, void *value)
{
	__asm
	{
		push	edx
		push	ecx
		mov		eax, dword ptr ds:[0xC97B24]
		call	[eax+0x20]
		add		esp, 8
		retn
	};
}




